dnl This is a little s script written by Rob Flynn of Linux Support Services, Inc.
dnl Hopefully, it will allow better detection of the Mozilla libraries.  Who knows ;-)
dnl If you have any patches, send them to:
dnl
dnl rob@linux-support.net
dnl
dnl Thanks! :-)
dnl

AC_DEFUN(CHECK_MOZILLA_DEVEL,[

dnl Ximian installs things in weird places sometimes. I stole
dnl part of this from Galeon, and then added on some things

if test -f /usr/lib/mozilla/chrome/embed.jar ; then
        DEFAULT_MOZILLA=/usr/lib/mozilla
elif test -f /usr/lib/mozilla-0.9.1/chrome/embed.jar ; then
        DEFAULT_MOZILLA=/usr/lib/mozilla-0.9.1
elif test -f /usr/lib/mozilla-0.9.2/chrome/embed.jar ; then
        DEFAULT_MOZILLA=/usr/lib/mozilla-0.9.2
elif test -f /usr/lib/mozilla-0.9.3/chrome/embed.jar ; then
        DEFAULT_MOZILLA=/usr/lib/mozilla-0.9.3
elif test -f /usr/lib/mozilla-0.9.4/chrome/embed.jar ; then
        DEFAULT_MOZILLA=/usr/lib/mozilla-0.9.4
else
	DEFAULT_MOZILLA=/usr/lib/mozilla
fi

dnl end Galeon theft :-)

AC_ARG_WITH(mozilla-lib,
	[  --with-mozilla-lib          Set mozilla's library directory ],
	[ MOZILLA_LIB_DIR="$withval"],
	[ MOZILLA_LIB_DIR="$DEFAULT_MOZILLA" ])

AC_ARG_WITH(mozilla-include,
	[  --with-mozilla-include     Set mozilla's header directory ],
	[ MOZILLA_INCLUDE_DIR="$withval"],
	[ MOZILLA_INCLUDE_DIR=/usr/include/mozilla ])

AC_ARG_WITH(mozilla-home,
	[  --with-mozilla-home        Set mozilla's home directory ],
	[ MOZILLA_HOME_DIR="$withval"],
	[ MOZILLA_HOME_DIR="$DEFAULT_MOZILLA" ])

dnl
dnl This was ugly. It proves what crack can do. Kids, dn't do drugs. I left this in here just
dnl so you can see how messed up a programmers mind can be when lack of sleep is involved.
dnl

dnl AC_CHECK_LIB(gtksuperwin, main,
dnl	AC_CHECK_LIB(gtkembedmoz, main,
dnl		AC_CHECK_LIB(plds4,main,
dnl			AC_CHECK_LIB(plc4,main,
dnl				AC_CHECK_LIB(nspr4,main,
dnl					AC_CHECK_LIB(xpcom,main,HASMOZILLA=yes,HASMOZILLA=no)
dnl				HASMOZILLA=no),
dnl			HASMOZILLA=no),
dnl		HASMOZILLA=no),
dnl	HASMOZILLA=no),
dnl HASMOZILLA=no)

old_CFLAGS="$CFLAGS"
CFLAGS="$CFLAGS -L$MOZILLA_LIB_DIR"

AC_CHECK_LIB(gtksuperwin, main,HASMOZILLA=yes,HASMOZILLA=no)
AC_CHECK_LIB(gtkembedmoz, main,,HASMOZILLA=no)
AC_CHECK_LIB(plds4,main,,HASMOZILLA=no)
AC_CHECK_LIB(plc4,main,,HASMOZILLA=no)
AC_CHECK_LIB(nspr4,main,,HASMOZILLA=no)
AC_CHECK_LIB(xpcom,main,,HASMOZILLA=no)

CFLAGS="$old_CFLAGS"

AC_MSG_CHECKING(for gtkmozembed.h)
AC_CACHE_VAL(has_gtkmozembed,[
	if test -f "$MOZILLA_INCLUDE_DIR/gtkmozembed.h" ; then
		CFLAGS="$CFLAGS -I$MOZILLA_INCLUDE_DIR -I$MOZILLA_INCLUDE_DIR/dist/include"
		has_gtkmozembed=yes
	else
		has_gtkmozembed=no
	fi
	])
AC_MSG_RESULT($has_gtkmozembed)

if test $has_gtkmozembed = no ; then
	echo "Could not find mozilla headers. Mozilla support will not be compiled.  You must have these headers"

	echo "installed in order to fully take advantage of gnophone's features"


	echo "Perhaps you should try --with-mozilla-include"
	echo ""	
fi

if test HASMOZILLA=yes ; then

	echo -n "searching for mozilla home ... "

	if test -f "$MOZILLA_HOME_DIR/chrome/embed.jar" ; then
		echo "$MOZILLA_HOME_DIR"

		MODULES="$MODULES html-mozilla.so"
		
		MOZILLALIBS="-L$MOZILLA_LIB_DIR -L$MOZILLA_LIB_DIR/dist/lib -lgtkembedmoz -lgtksuperwin -lplds4 -lplc4 -lnspr4 -lxpcom"

		LIBS="$LIBS -lpthread"

		AC_SUBST(MOZILLALIBS)
		AC_SUBST(MOZILLA_LIB_DIR)
		AC_SUBST(MOZILLA_INCLUDE_DIR)
		AC_SUBST(MOZILLA_HOME_DIR)

	else
		echo "not found. Try using --with-mozilla-home"
	fi
fi

AC_SUBST(HASMOZILLA)

])
